---
title: PerformanceObserver.observe()
slug: Web/API/PerformanceObserver/observe
tags:
  - API
  - Method
  - Performance
  - PerformanceObserver
  - Reference
  - Web Performance
---
<div>{{APIRef("Performance Timeline API")}}</div>

<p><span class="seoSummary">The <strong><code>observe()</code></strong> method of the<strong> {{domxref("PerformanceObserver")}}</strong> interface is used to specify the set of performance entry types to observe. </span>The performance entry types are specified as an array of {{domxref("DOMString")}} objects, each naming one entry type; the type names are documented in {{SectionOnPage("/en-US/docs/Web/API/PerformanceEntry/entryType", "Performance entry type names")}}.</p>

<p>When a matching performance entry is recorded, the performance observer's callback function—set when creating the {{domxref("PerformanceObserver")}}—is invoked.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>observer</em>.observe(<em>options</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>options</code></dt>
 <dd>A <code>PerformanceObserverInit</code> dictionary with the following possible members:
 <ul>
  <li><code>entryTypes</code>: An array of {{domxref("DOMString")}} objects, each specifying one performance entry type to observe.  May not be used together with the "<code>type</code>" or "<code>buffered</code>" options.</li>
  <li><code>type</code>: A single {{domxref("DOMString")}} specifying exactly one performance entry type to observe.  May not be used together with the <code>entryTypes</code> option.</li>
  <li><code>buffered</code>: A {{jsxref("Boolean")}} flag to indicate whether buffered entries should be queued into the observer's buffer.  Must be used only with the "<code>type</code>" option.</li>
 </ul>

 <p>See {{domxref("PerformanceEntry.entryType")}} for a list of valid performance entry type names. Unrecognized types are ignored, though the browser may output a warning message to the console to help developers debug their code. If no valid types are found, <code>observe()</code> has no effect.</p>
 </dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>This example creates and configures two <code>PerformanceObservers</code>; one watches for <code>"mark"</code> and <code>"frame"</code> events, and the other watches for <code>"measure"</code> events.</p>

<pre class="brush: js">var observer = new PerformanceObserver(function(list, obj) {
  var entries = list.getEntries();
  for (var i=0; i &lt; entries.length; i++) {
    // Process "mark" and "frame" events
  }
});
observer.observe({entryTypes: ["mark", "frame"]});

function perf_observer(list, observer) {
  // Process the "measure" event
}
var observer2 = new PerformanceObserver(perf_observer);
observer2.observe({entryTypes: ["measure"]});
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Performance Timeline Level 2', '#dom-performanceobserver-observe', 'observe()')}}</td>
   <td>{{Spec2('Performance Timeline Level 2')}}</td>
   <td>Initial definition of <code>observe()</code> method.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.PerformanceObserver.observe")}}</p>
</div>
